Red/System [
	Title:   "Red/System small demo app"
	Author:  "jocko"
	File: 	 %demoTTS.reds
	Rights:  "Copyright (C) 2011 Nenad Rakocevic. All rights reserved."
	License: "BSD-3 - https://github.com/dockimbel/Red/blob/origin/BSD-3-License.txt"
]

; --- comment --------

{ demo of a dialog, using the Google TTS api.

a custom dll has been written, based on the reference :
http://www.codeproject.com/KB/audio-video/GoogleTTS-Ebook-Reader.aspx 
This demo is only executable under windows, and requests an Internet link

Tested with Windows XP and red/system 0.2.1

compilation: do/args %rsc.r "%demoTTS.reds -t Windows"
}

; --- lib imports -----

#import [
	"tts-jc.dll" cdecl [
		r2M_version: "Version" [  ;dll version
			return: [c-string!] 
			]
		TTS: "TTS" [  ;TTS from SAPI ... if installed
			lpStr [c-string!]
		return: [integer!]
		]  
		gTTS: "gTTS" [	;TTD from Google TTS ... if internet accessible
			lpStr [c-string!]
		return: [integer!]
		]
		TTSlng: "TTSlng" [  ;change the base language for Google TTS
			lng [c-string!]
		return: [integer!]
		]
	]
	"user32.dll" stdcall [
		MessageBox: "MessageBoxA" [
			handle		[integer!] ;__in_opt  HWND hWnd,
			text		[c-string!] ;__in_opt  LPCTSTR lpText,
			title		[c-string!] ; __in_opt  LPCTSTR lpCaption,
			type 		[integer!]	; __in      UINT uType
		return:	[integer!]
		]
  	]
]

alert: func [txt [c-string!] return: [integer!]][
	MessageBox 0 txt "alert" 48 
	]
	
confirm: func [txt [c-string!] return: [integer!] /local rep [integer!]][
	rep: MessageBox 0 txt "confirm" 4 
	if rep = 6 [rep: 1]  ; sinon rep = 7
	rep
]
	
; ---- beginning of the program ----------

french: confirm "french speaking ?"

txt1: "Red System is amazing"
txt2: "I say, Red is astonishing"
txt3: "of course I am right"
txt4: "am I right ?"
txt5: "ok, bye ..."

if french = 1 [
	TTSlng "fr"  ; for french language (or whatever ...)
	txt1: "Red System est tonnant"
	txt2: "Je rpte, Red est fantastique"
	txt3: "bien sr que j'ai raison"
	txt4: "est-ce que j'ai raison ?"
	txt5: "salut ..."
]

rep: 0

until [
	gTTS txt1
	txt1: txt2
	rep: confirm txt4
	rep = 1
]

gTTS txt3
alert txt5
